'''
Created on Oct 5, 2009

@author: kenji
'''

#!/usr/bin/env python

import pygtk
import gtk
import gobject
import os
import dircache

#################### AUXILIARY FUNCTIONS ######################
    

def __file_entry_changed(editable, *user_data):
    comp = user_data[0]
    text = editable.get_text()
    matches = []
    if text.startswith("~"):
        home = os.environ["HOME"]
        editable.set_text(home)
    elif text:
        path = os.path.dirname(text)
        start = os.path.basename(text)
        if os.path.exists(path):
            files = dircache.listdir(path)
            for file in files:
                if file.startswith(start):
                    if path == "/":
                        matches.append(path+file)
                    else:
                        matches.append(path+os.sep+file)
        model = comp.get_model()
        model.clear()
        for match in matches:
            model.append([match])
    
def __create_filechooser_frame():
    '''Create the filechooser frame
    @param widgets_callback_dictionary: a dictionary containing widgets to be connected to a callback
    @return: gtk.Frame'''
    frame = gtk.Frame()
    vbox = gtk.VBox(False)
    # File properties
    hbox_file = gtk.HBox(False)
    file_label = gtk.Label(" File: ")
    hbox_file.pack_start(file_label, False, False, 0)
    file_entry = gtk.Entry()
    file_entry.set_tooltip_text("Select the video source")
    hbox_file.pack_start(file_entry, False, False, 0)
    vbox.pack_start(hbox_file, False, False, 0)
    # Initial frame properties
    hbox_init_frame = gtk.HBox(False)
    init_frame_label = gtk.Label(" Initial Frame: ")
    hbox_init_frame.pack_start(init_frame_label, False, False, 0)
    event_box = gtk.EventBox()
    init_frame_entry = gtk.Entry()
    event_box.add(init_frame_entry)
    init_frame_entry.set_text(str(0))
    init_frame_entry.set_tooltip_text("Insert the starting frame for this video")
    init_frame_entry.set_size_request(100, -1)
    hbox_init_frame.pack_start(event_box, False, False, 0)
    vbox.pack_start(hbox_init_frame, False, False, 0)
    frame.add(vbox)
    # Setting up the file entry auto-completion
    completion = gtk.EntryCompletion()
    completion.set_property("popup-set-width", False)
    completion.set_property("inline-completion", True)
    file_entry.set_completion(completion)
    liststore = gtk.ListStore(gobject.TYPE_STRING)
    completion.set_model(liststore)
    completion.set_text_column(0)
    file_entry.connect("changed", __file_entry_changed, completion)
    return frame

#################### BUTTON CALLBACKS ####################

def cb_click_play_button(button, pause_button):
    '''Connect the default "click" callback to a Play button
    @param button: gtk.Button'''
    button.hide()
    pause_button.set_no_show_all(False)
    pause_button.show()

def cb_click_pause_button(button, play_button):
    '''Connect the default "click" callback to a Pause button
    @param button: gtk.Button'''
    button.hide()
    play_button.set_no_show_all(False)
    play_button.show()

def cb_click_stop_button(button, play_button, pause_button):
    '''Connect the default "click" callback to a Stop button
    @param button: gtk.Button
    @param play_button: gtk.Button
    @param pause_button: gtk.Button'''
    pause_button.hide()
    play_button.set_no_show_all(False)
    play_button.show()
        
def cb_click_lock_togglebutton(togglebutton, main_window_callback_dictionary):
    '''Connect the default "click" callback to a Lock toggle button
    @param togglebutton: gtk.Button
    @param widgets_callback_dictionary: a dictionary containing widgets to be connected to a callback'''
    # Retrieving information
    x_display_control = main_window_callback_dictionary["Callback_Toolbar_X_Display_Control"]
    y_display_control = main_window_callback_dictionary["Callback_Toolbar_Y_Display_Control"]
    filechooser_panel = main_window_callback_dictionary["Callback_Panel_Filechooser"]
    fluxcontrol_panel = main_window_callback_dictionary['Callback_Panel_Fluxcontrol']
    if togglebutton.get_property("active"):
        # Turn off the sensitivity of the spin buttons
        x_display_control.set_sensitive(False)
        y_display_control.set_sensitive(False)
        # Get the number of lines and columns 
        lines = int(x_display_control.get_children()[0].get_children()[1].get_value())
        columns = int(y_display_control.get_children()[0].get_children()[1].get_value())
        # Resize the table
        table = filechooser_panel.get_children()[0]
        children = table.get_children()
        for child in children:
            table.remove(child)
        table.resize(lines, columns)
        # Set the frames
        current_frame = 0
        for i in range(columns):
            for j in range(lines):
                frame = __create_filechooser_frame()
                frame.set_name("Callback_Frame_Filechooser_" + str(current_frame))
                main_window_callback_dictionary[frame.get_name()] = frame
                table.attach(frame, i, i+1, j, j+1, gtk.EXPAND | gtk.FILL, gtk.EXPAND | gtk.FILL, 2, 2)
                current_frame += 1
        # Show up the lower panels
        filechooser_panel.set_no_show_all(False)
        fluxcontrol_panel.set_no_show_all(False)
        filechooser_panel.show_all()
        fluxcontrol_panel.show_all()
    elif not togglebutton.get_property("active"):
        # Turn on the sensitivity of the spin buttons
        x_display_control.set_sensitive(True)
        y_display_control.set_sensitive(True)
        # Hide the lower panels
        filechooser_panel.set_no_show_all(True)
        fluxcontrol_panel.set_no_show_all(True)
        filechooser_panel.hide()
        fluxcontrol_panel.hide()
                
