'''
Created on Aug 26, 2009

@author: marumjr
'''

#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk

class ButtonFactory():
    '''Button Factory class, from which we extract some standard buttons'''
    
    __image_path = "./../img/"
    
    @staticmethod
    def __create_default_image_button(name, image_name, tooltip_text=None):
        '''Create a general button
        @param name: the name of the button
        @param image: the image to be displayed inside the button
        @param tooltip_text: the text which will be displayed as the mouse is on the button
        @return: gtk.Button'''
        button = gtk.Button()
        button.set_name("Callback_Button" + name)
        image = gtk.Image()
        image.set_from_file(image_name)
        button.set_image(image)
        button.set_tooltip_text(tooltip_text)
        return button
    
    @staticmethod
    def __create_default_button(name, tooltip_text=None):
        '''Create a general button
        @param name: the name of the button
        @param tooltip_text: the text which will be displayed as the mouse is on the button
        @return: gtk.Button'''
        button = gtk.Button()
        button.set_name("Callback_Button" + name)
        button.set_label(name)
        button.set_tooltip_text(tooltip_text)
        return button
    
    @staticmethod
    def create_rew_button():
        '''Create a Rewind Button
        @return: gtk.Button'''
        button_name = "_Rewind"
        image_name = "gtk-media-rew.png"
        tooltip_text = "Goes to the previous frame"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    @staticmethod
    def create_prev_button():
        '''Create a Previous Button
        @return: gtk.Button'''
        button_name = "_Previous"
        image_name = "gtk-media-prev.png"
        tooltip_text = "Instantly goes to the initial frame of each video"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    @staticmethod
    def create_play_button():
        '''Create a Play Button
        @return: gtk.Button'''
        button_name = "_Play"
        image_name = "gtk-media-play.png"
        tooltip_text = "Plays the videos"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    @staticmethod
    def create_pause_button():
        '''Create a Pause Button
        @return: gtk.Button'''
        button_name = "_Pause"
        image_name = "gtk-media-pause.png"
        tooltip_text = "Pause the videos"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    @staticmethod
    def create_stop_button():
        '''Create a Stop Button
        @return: gtk.Button'''
        button_name = "_Stop"
        image_name = "gtk-media-stop.png"
        tooltip_text = "Stop the current video thread"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    @staticmethod
    def create_next_button():
        '''Create a Next Button
        @return: gtk.Button'''
        button_name = "_Next"
        image_name = "gtk-media-next.png"
        tooltip_text = "Instantly goes to the last frame of each video"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    @staticmethod
    def create_fwd_button():
        '''Create a Fastforward Button
        @return: gtk.Button'''
        button_name = "_Fastforward"
        image_name = "gtk-media-fwd.png"
        tooltip_text = "Goes to the next frame"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path, tooltip_text)
        return button
    
    ############################################################################
    
    @staticmethod
    def create_filechooser_button():
        '''Create a Filechooser Selection Button
        @return: gtk.Button'''
        button_name = "_Filechooser"
        image_name = "gtk-media-next.png"
        image_complete_path = ButtonFactory.__image_path + image_name
        button = ButtonFactory.__create_default_image_button(button_name, image_complete_path)
        return button
    
    #############################################################################
    
    @staticmethod
    def create_view_window_button():
        '''Create a View Window Button
        @return: gtk.Button'''
        button_name = "_View"
        button = ButtonFactory.__create_default_button(button_name)
        return button
    
    @staticmethod
    def create_sync_window_button():
        '''Create a Synchronize Window Button
        @return: gtk.Button'''
        button_name = "_Synchronize"
        button = ButtonFactory.__create_default_button(button_name)
        return button
        
