'''
Created on Oct 31, 2009

@author: marumjr
'''

#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk

class StandardComponentFactory():
    '''Standard component class, from which we extract some standard general components'''
    
    @staticmethod
    def create_general_entry(name, size, text, tooltip_text):
        '''Create a general entry
        @param name: the name of the entry
        @param size: number of chars that can be displayed in the entry
        @param text: text to be set in
        @param tooltip_text: tooltip text to be displayed as the mouse is over the entry
        @return: gtk.Entry'''
        entry = gtk.Entry()
        entry.set_name(name)
        entry.set_size_request(12 * size, -1)
        entry.set_text(text)
        entry.set_tooltip_text(tooltip_text)
        return entry
    
    @staticmethod
    def create_general_label(name, text):
        '''Create a general label
        @param name: the name of the label
        @param text: text to be set in
        @return: gtk.Label'''
        label = gtk.Label(text)
        label.set_name(name)
        return label
    