'''
Created on Sep 7, 2009

@author: marumjr
'''

#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk

class ToolFactory():
    '''Tool Factory class, from which we extract some standard tool items'''
    
    __image_path = "./../img/"
    
    @staticmethod
    def __create_video_general_display_control(name, icon_name, tooltip):
        '''Create a spin button which control the number of videos displayed on a determined axis
        @return: gtk.ToolItem'''
        tool_item = gtk.ToolItem()
        tool_item.set_name("Callback_Toolbar" + name)
        # X coordinate control
        control_box = gtk.HBox(False, 0)
        icon = gtk.Image()
        icon.set_from_file(ToolFactory.__image_path + icon_name)
        control_box.pack_start(icon, False, True, 0)
        adj = gtk.Adjustment(1.0, 1.0, 5.0, 1.0, 1.0, 0.0)
        spinner = gtk.SpinButton(adj, 0, 0)
        spinner.set_numeric(True)
        control_box.pack_start(spinner, False, True, 0)
        # Returning the button
        tool_item.add(control_box)
        tool_item.set_tooltip_text(tooltip)
        return tool_item
    
    @staticmethod
    def __create_default_togglebutton(name, label, tooltip):
        '''Create a default toggle button
        @param name: name
        @param label: label
        @param tooltip: tooltip
        @return: gtk.ToggleToolButton'''
        toggle_button = gtk.ToggleToolButton()
        toggle_button.set_name("Callback_Toolbar_ToggleButton" + name)
        toggle_button.set_label(label)
        toggle_button.set_tooltip_text(tooltip)
        return toggle_button
    
    @staticmethod
    def create_video_x_display_control():
        '''Create a spin button which control the number of videos displayed on the horizontal axis
        @return: gtk.ToolItem'''
        name = "_X_Display_Control"
        icon_name = "gtk-table-vscale.png"
        tooltip = "Set the number of videos that can be displayed on the horizontal axis"
        tool_item = ToolFactory.__create_video_general_display_control(name, icon_name, tooltip)
        return tool_item
    
    @staticmethod
    def create_video_y_display_control():
        '''Create a spin button which control the number of videos displayed on the vertical axis
        @return: gtk.ToolItem'''
        name = "_Y_Display_Control"
        icon_name = "gtk-table-hscale.png"
        tooltip = "Set the number of videos that can be displayed on the vertical axis"
        tool_item = ToolFactory.__create_video_general_display_control(name, icon_name, tooltip)
        return tool_item
        
    @staticmethod
    def create_lock_togglebutton():
        '''Create a toggle tool button which locks the current video configurations
        @return: gtk.ToggleToolButton'''
        name = "_Lock"
        label = "Lock"
        tooltip = "Lock the current videos disposition configuration"
        tool_item = ToolFactory.__create_default_togglebutton(name, label, tooltip)
        return tool_item
        
